# Modified version of lassp sss package grtools.tcl
# jps 9/18/96

###############################################################
#
proc PYTgrzoom {g} {
    upvar #0 $g c
    set c(zoomboxtag) [$g tag create line] 


    bind $g <Button-3> {
	#save screen coords and get x0,y0 in graph coords
	set %W(screenx0) %x
	set %W(screeny0) %y
	set %W(x0) [lindex [%W invtransform %x %y] 0]
	set %W(y0) [lindex [%W invtransform %x %y] 1]
	
	#clip to viewable region on graph
	if {[set %W(x0)] < [lindex [%W xaxis limits] 0]} {
	    set %W(x0) [lindex [%W xaxis limits] 0]
	}
	if {[set %W(x0)] > [lindex [%W xaxis limits] 1]} {
	    set %W(x0) [lindex [%W xaxis limits] 1]
	}
	if {[set %W(y0)] < [lindex [%W yaxis limits] 0]} {
	    set %W(y0) [lindex [%W yaxis limits] 0]
	}
	if {[set %W(y0)] > [lindex [%W yaxis limits] 1]} {
	    set %W(y0) [lindex [%W yaxis limits] 1]
	}
    }

# Button-3 to Control-Button-1 - rbr
    bind $g <Control-Button-1> {
	#save screen coords and get x0,y0 in graph coords
	set %W(screenx0) %x
	set %W(screeny0) %y
	set %W(x0) [lindex [%W invtransform %x %y] 0]
	set %W(y0) [lindex [%W invtransform %x %y] 1]
	
	#clip to viewable region on graph
	if {[set %W(x0)] < [lindex [%W xaxis limits] 0]} {
	    set %W(x0) [lindex [%W xaxis limits] 0]
	}
	if {[set %W(x0)] > [lindex [%W xaxis limits] 1]} {
	    set %W(x0) [lindex [%W xaxis limits] 1]
	}
	if {[set %W(y0)] < [lindex [%W yaxis limits] 0]} {
	    set %W(y0) [lindex [%W yaxis limits] 0]
	}
	if {[set %W(y0)] > [lindex [%W yaxis limits] 1]} {
	    set %W(y0) [lindex [%W yaxis limits] 1]
	}
    }

    bind $g <B3-Motion> {
	#get x1,y1 and clip to viewable region on graph
	set %W(x1) [lindex [%W invtransform %x %y] 0]
	set %W(y1) [lindex [%W invtransform %x %y] 1]
	if {[set %W(x1)] < [lindex [%W xaxis limits] 0]} {
	    set %W(x1) [lindex [%W xaxis limits] 0]
	}
	if {[set %W(x1)] > [lindex [%W xaxis limits] 1]} {
	    set %W(x1) [lindex [%W xaxis limits] 1]
	}
	if {[set %W(y1)] < [lindex [%W yaxis limits] 0]} {
	    set %W(y1) [lindex [%W yaxis limits] 0]
	}
	if {[set %W(y1)] > [lindex [%W yaxis limits] 1]} {
	    set %W(y1) [lindex [%W yaxis limits] 1]
	}

	#redraw the zooming box
	%W tag coords [set %W(zoomboxtag)] "   \
		[set %W(x0)] [set %W(y0)]  \
		[set %W(x1)] [set %W(y0)]  \
		[set %W(x1)] [set %W(y1)]  \
		[set %W(x0)] [set %W(y1)]  \
		[set %W(x0)] [set %W(y0)]"  
    }

#B3-Motion to Control-B1-Motion - rbr
    bind $g <Control-B1-Motion> {
	#get x1,y1 and clip to viewable region on graph
	set %W(x1) [lindex [%W invtransform %x %y] 0]
	set %W(y1) [lindex [%W invtransform %x %y] 1]
	if {[set %W(x1)] < [lindex [%W xaxis limits] 0]} {
	    set %W(x1) [lindex [%W xaxis limits] 0]
	}
	if {[set %W(x1)] > [lindex [%W xaxis limits] 1]} {
	    set %W(x1) [lindex [%W xaxis limits] 1]
	}
	if {[set %W(y1)] < [lindex [%W yaxis limits] 0]} {
	    set %W(y1) [lindex [%W yaxis limits] 0]
	}
	if {[set %W(y1)] > [lindex [%W yaxis limits] 1]} {
	    set %W(y1) [lindex [%W yaxis limits] 1]
	}

	#redraw the zooming box
	%W tag coords [set %W(zoomboxtag)] "   \
		[set %W(x0)] [set %W(y0)]  \
		[set %W(x1)] [set %W(y0)]  \
		[set %W(x1)] [set %W(y1)]  \
		[set %W(x0)] [set %W(y1)]  \
		[set %W(x0)] [set %W(y0)]"  
    }

    bind $g <ButtonRelease-3> {
	#get rid of zoom box on screen
	%W tag coords [set %W(zoomboxtag)] {1 1 1 1}

	# call pythag package if click with no motion
	if {abs(%x-[set %W(screenx0)]) < 3  &&  \
	    abs(%y-[set %W(screeny0)]) < 3} {
	    reset_scales
	    break
	}

	#get x,y in graph coords
	set %W(x1) [lindex [%W invtransform %x %y] 0]
	set %W(y1) [lindex [%W invtransform %x %y] 1]

	#clip to viewable region on graph
	if {[set %W(x1)] < [lindex [%W xaxis limits] 0]} {
	    set %W(x1) [lindex [%W xaxis limits] 0]
	}
	if {[set %W(x1)] > [lindex [%W xaxis limits] 1]} {
	    set %W(x1) [lindex [%W xaxis limits] 1]
	}
	if {[set %W(y1)] < [lindex [%W yaxis limits] 0]} {
	    set %W(y1) [lindex [%W yaxis limits] 0]
	}
	if {[set %W(y1)] > [lindex [%W yaxis limits] 1]} {
	    set %W(y1) [lindex [%W yaxis limits] 1]
	}

	#make sure that x1>x0, y1>y0
	if {[set %W(x1)] < [set %W(x0)]} {
	    set %W(temp) [set %W(x1)]
	    set %W(x1) [set %W(x0)]
	    set %W(x0) [set %W(temp)]
	}
	if {[set %W(y1)] < [set %W(y0)]} {
	    set %W(temp) [set %W(y1)]
	    set %W(y1) [set %W(y0)]
	    set %W(y0) [set %W(temp)]
	}

	#set new axis limits
	if {[set %W(x0)] != [set %W(x1)]} {
	    %W xaxis configure -min [set %W(x0)] -max [set %W(x1)]
	}
	if {[set %W(y0)] != [set %W(y1)]} {
	    %W yaxis configure -min [set %W(y0)] -max [set %W(y1)]
	}
    }
    
# ButtonRelease-3 to Control-ButtonRelease-1
    bind $g <Control-ButtonRelease-1> {
	#get rid of zoom box on screen
	%W tag coords [set %W(zoomboxtag)] {1 1 1 1}

	#call pythag reset_scales if click with no motion
	if {abs(%x-[set %W(screenx0)]) < 3  &&  \
	    abs(%y-[set %W(screeny0)]) < 3} {
	    reset_scales
	    break
	}

	#get x,y in graph coords
	set %W(x1) [lindex [%W invtransform %x %y] 0]
	set %W(y1) [lindex [%W invtransform %x %y] 1]

	#clip to viewable region on graph
	if {[set %W(x1)] < [lindex [%W xaxis limits] 0]} {
	    set %W(x1) [lindex [%W xaxis limits] 0]
	}
	if {[set %W(x1)] > [lindex [%W xaxis limits] 1]} {
	    set %W(x1) [lindex [%W xaxis limits] 1]
	}
	if {[set %W(y1)] < [lindex [%W yaxis limits] 0]} {
	    set %W(y1) [lindex [%W yaxis limits] 0]
	}
	if {[set %W(y1)] > [lindex [%W yaxis limits] 1]} {
	    set %W(y1) [lindex [%W yaxis limits] 1]
	}

	#make sure that x1>x0, y1>y0
	if {[set %W(x1)] < [set %W(x0)]} {
	    set %W(temp) [set %W(x1)]
	    set %W(x1) [set %W(x0)]
	    set %W(x0) [set %W(temp)]
	}
	if {[set %W(y1)] < [set %W(y0)]} {
	    set %W(temp) [set %W(y1)]
	    set %W(y1) [set %W(y0)]
	    set %W(y0) [set %W(temp)]
	}

	#set new axis limits
	if {[set %W(x0)] != [set %W(x1)]} {
	    %W xaxis configure -min [set %W(x0)] -max [set %W(x1)]
	}
	if {[set %W(y0)] != [set %W(y1)]} {
	    %W yaxis configure -min [set %W(y0)] -max [set %W(y1)]
	}
    }
}



